package es.uv.garcosda.controllers;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import es.uv.garcosda.services.NotificationService;
import es.uv.garcosda.domain.Notification;

@RestController
@RequestMapping("/api/v1/notifications")
public class NotificationController {

	@Autowired
	NotificationService ns;
	
	@GetMapping("")
	public ResponseEntity<?> notifications() {
		return new ResponseEntity<List<Notification>>(this.ns.findAll(), HttpStatus.OK);
	}
	
	@GetMapping("{owner}")
	public ResponseEntity<?> notifications(@PathVariable("owner") String owner){
		List<Notification> notifications = this.ns.findByOwner(owner);
		if(notifications.size() > 0) {
			return new ResponseEntity<List<Notification>>(notifications, HttpStatus.OK);
		}
		else {
			return new ResponseEntity<String>("No notifications found for owner "+owner, HttpStatus.NOT_FOUND);
		}
		
	}
	
	@DeleteMapping("")
	public ResponseEntity<?> delete(){
		this.ns.clear();
		return new ResponseEntity<String>("Notification list cleaned", HttpStatus.OK);
	}
	
}
