package es.uv.garcosda.services;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.stereotype.Service;

import es.uv.garcosda.domain.Notification;

@Service
public class NotificationService {

	List<Notification> notifications;
	
	public NotificationService() {
		this.notifications = new ArrayList<Notification>();
	}
	
	public List<Notification> findAll(){
		return this.notifications;
	}
	
	public List<Notification> findByOwner(String owner) {
		List<Notification> ps = this.notifications.stream().filter(x -> x.getDocument().getOwner().toLowerCase().equals(owner.toLowerCase())).collect(Collectors.toList());
		return ps;
	}
	
	public void add(Notification notification) {
		this.notifications.add(notification);
	}
	
	public void clear() {
		this.notifications.clear();
	}
	
	
}
